/*
 * File         : test4.java
 * Author       : Guansong Zhang
 * Revised by	: Qiang Zheng
 * Created      : Thu Jan  8 14:07:22 1998
 * Revision     : $Revision: 1.7 $
 * Updated      : $Date: 1998/11/13 19:48:26 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

// real a(10, 10), b(10, 10)
//
// !hpf$ distribute a (block, block) onto p
// !hpf$ align b (i, j) with a (j, i)
// !hpf$ processors p (2, 2)
//
// do i = 1, 10
//   do j = 1, 10
//     a (i, j) = 10 * i + j
//   enddo
// enddo
//
// b = a + 2
//
// do i = 1, 10
//   print "(10f7.1)", b(i, :)
// enddo
//
// end

import hpjava.spmd.*;
import hpjava.spmd.adlib.*;
import hpjava.lang.*;

class test4 {

    static SpmdEnv spmd;
    static Procs1 p;
    static BlockRange x;
	static Range xc;
    static Array1dF u,um, uL, uR,tmp1, tmp2;
    static Index i;
	static Array1dF sect;

  public static void main(String argv[]) {

    spmd=new SpmdEnv(argv);
    p=new Procs1(4);

    if (p.on()) {

      x = new BlockRange (10, p.dim(0));
      u = new Array1dF(spmd.apg,x);

      i = new Index (x);

      i.dim().over();
      for (i.begin(); i.test(); i.next()) {
	if (x.idx(i)==0 || x.idx(i)==9)
	  u.dat()[u.pos(i)]=1;
	else
	  u.dat()[u.pos(i)]=0;
      } i.dim().revo();

      xc=x.subrng(8, 1, 1);      

      uL=new Array1dF(p,x.subrng(8,0),u.str()[0],u.dat(),u.off());
      uR=new Array1dF(p,x.subrng(8,2),u.str()[0],u.dat(),u.off());

      tmp1= new Array1dF(spmd.apg,xc);
      tmp2= new Array1dF(spmd.apg,xc);
      
      for (int n=1; n<=5; n++) {
	Adlib.remap(tmp1, uL);
	Adlib.remap(tmp2, uR);

	Index ic = new Index (xc);

	i.dim().over();
	for (ic.begin(); ic.test(); ic.next()) {
	  u.dat()[u.pos(ic)]=(float)0.5*
	    (tmp1.dat()[tmp1.pos(ic)]+tmp2.dat()[tmp2.pos(ic)]);
	} ic.dim().revo();

	//Adlib.gprintf("iteration = %d\n", n);
	//Spmd.rout.println("iteration = "+n);
	Adlib.rprintln("iteration = "+n);
	Adlib.aprintf("%2R0%7.3f\n", u);
      }
    } p.no();
    spmd.finalize();
  }
}
